searchNodes=[{"doc":"&lt;img id=&quot;avroraLogo&quot; width=200 src=&quot;/assets/logo.png&quot;/&gt; &lt;h1 align=&quot;center&quot;&gt;Avrora&lt;/h1&gt;[![Hex pm](https://img.shields.io/hexpm/v/avrora.svg?style=for-the-badge)](https://hex.pm/packages/avrora)[![Hex Docs](https://img.shields.io/badge/api-docs-blue.svg?style=for-the-badge)](https://hexdocs.pm/avrora)[![Build Status](https://img.shields.io/travis/Strech/avrora/master?style=for-the-badge)](https://travis-ci.org/Strech/avrora)Getting StartedThis library supports convenient encoding and decoding of Avro messages.It can read the Avro schema from local files or the Confluent® Schema Registry, caching data in memory for performance. It supports reading and writing data Kafka wire format prefix and from Object Container Files formats. And has Inter-Schema references feature.Many thanks to the AvroTurf Ruby gem for the inspiration.Add Avrora to your projectAdd Avrora to mix.exs as a dependency:def deps do [ {:avrora, &quot;~&gt; 0.13&quot;} ] endConfigurationConfigure the library in config/config.exs:config :avrora, registry_url: &quot;http://localhost:8081&quot;, registy_auth: {:basic, [&quot;username&quot;, &quot;password&quot;]}, # optional registy_schemas_autoreg: false, # optional: if you want manually register schemas schemas_path: Path.expand(&quot;./priv/schemas&quot;), names_cache_ttl: :timer.minutes(5) # optional: if you want periodic disk readsregistry_url - URL for the Schema Registry, default nilregistry_auth – Credentials to authenticate in the Schema Registry, default nilregisty_schemas_autoreg - Flag for automatic schemas registration in the Schema Registry, default true (since v0.13)schemas_path - Base path for locally stored schema files, default ./priv/schemasnames_cache_ttl - Time in ms to cache schemas by name in memory, default :infinity (since v0.10)Set names_cache_ttl to :infinity will cache forever (no more disk reads will happen). This is safe when schemas are resolved in the Schema Registry by numeric id or versioned name, as it is unique. If you need to reload schema from the disk periodically, TTL different from :infinity ensures that.If the schema is resolved by name it will be always overwritten with the latest schema received from Schema Registry (this is a new behavior since v0.10).:bulb: Disable automatic schemas registration if you want to avoid storing schemas and manually control registration process.Start cache processAvrora uses an in-memory cache to speed up schema lookup.Add it to your supervision tree:children = [ Avrora ] Supervisor.start_link(children, strategy: :one_for_one)Or start the cache process manually:{:ok, pid} = Avrora.start_link()UsageThe primary way to use the library is via the Avrora.encode/2 and Avrora.decode/2 functions. These functions load the Avro schema for you.If registry_url is defined, it enables Schema Registry storage. If the schema file found locally but not in the registry, either fuction will register the schema.These examples assume you have a Payment schema stored in the file priv/schemas/io/confluent/Payment.avsc:{ &quot;type&quot;: &quot;record&quot;, &quot;name&quot;: &quot;Payment&quot;, &quot;namespace&quot;: &quot;io.confluent&quot;, &quot;fields&quot;: [ { &quot;name&quot;: &quot;id&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;amount&quot;, &quot;type&quot;: &quot;double&quot; } ] }When running interactively, first make sure the cache is started:{:ok, pid} = Avrora.start_link()encode/2To encode a Payment message:{:ok, pid} = Avrora.start_link() message = %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99} {:ok, encoded} = Avrora.encode(message, schema_name: &quot;io.confluent.Payment&quot;) &lt;&lt;79, 98, 106, 1, 3, 204, 2, 20, 97, 118, 114, 111, 46, 99, 111, 100, 101, 99, 8, 110, 117, 108, 108, 22, 97, 118, 114, 111, 46, 115, 99, 104, 101, 109, 97, 144, 2, 123, 34, 110, 97, 109, 101, 115, 112, 97, 99, 101, 34, 58, 34, 105, 111, 46, 99, 111, 110, 102, 108, 117, 101, 110, 116, 34, 44, 34, 110, 97, 109, 101, 34, 58, 34, 80, 97, 121, 109, 101, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 114, 101, 99, 111, 114, 100, 34, 44, 34, 102, 105, 101, 108, 100, 115, 34, 58, 91, 123, 34, 110, 97, 109, 101, 34, 58, 34, 105, 100, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 115, 116, 114, 105, 110, 103, 34, 125, 44, 123, 34, 110, 97, 109, 101, 34, 58, 34, 97, 109, 111, 117, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 100, 111, 117, 98, 108, 101, 34, 125, 93, 125, 0, 138, 124, 66, 49, 157, 51, 242, 3, 33, 52, 161, 147, 221, 174, 114, 48, 2, 26, 8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64, 138, 124, 66, 49, 157, 51, 242, 3, 33, 52, 161, 147, 221, 174, 114, 48&gt;&gt;The :format argument controls output format::plain - Just return Avro binary data, with no header or embedded schema:ocf - Use Object Container File format, embedding the full schema with the data:registry - Write data with Confluent Schema Registry Wire Format, which prefixes the data with the schema id:guess - Use :registry if possible, otherwise use :ocf (default){:ok, pid} = Avrora.start_link() message = %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99} {:ok, encoded} = Avrora.encode(message, schema_name: &quot;io.confluent.Payment&quot;, format: :plain) &lt;&lt;8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt;decode/2Decode Payment message using the specified schema:{:ok, pid} = Avrora.start_link() message = &lt;&lt;8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; {:ok, decoded} = Avrora.decode(message, schema_name: &quot;io.confluent.Payment&quot;) %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99}decode/1Decode a message, auto-detecting the schema using magic bytes. It first tries resolving the schema using the integer id in the wire format header.Next it tries reading using the Object Container Files embedded schema.NOTE: Messages encoded with OCF are wrapped in a List.{:ok, pid} = Avrora.start_link() message = &lt;&lt;79, 98, 106, 1, 3, 204, 2, 20, 97, 118, 114, 111, 46, 99, 111, 100, 101, 99, 8, 110, 117, 108, 108, 22, 97, 118, 114, 111, 46, 115, 99, 104, 101, 109, 97, 144, 2, 123, 34, 110, 97, 109, 101, 115, 112, 97, 99, 101, 34, 58, 34, 105, 111, 46, 99, 111, 110, 102, 108, 117, 101, 110, 116, 34, 44, 34, 110, 97, 109, 101, 34, 58, 34, 80, 97, 121, 109, 101, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 114, 101, 99, 111, 114, 100, 34, 44, 34, 102, 105, 101, 108, 100, 115, 34, 58, 91, 123, 34, 110, 97, 109, 101, 34, 58, 34, 105, 100, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 115, 116, 114, 105, 110, 103, 34, 125, 44, 123, 34, 110, 97, 109, 101, 34, 58, 34, 97, 109, 111, 117, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 100, 111, 117, 98, 108, 101, 34, 125, 93, 125, 0, 84, 229, 97, 195, 95, 74, 85, 204, 143, 132, 4, 241, 94, 197, 178, 106, 2, 26, 8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64, 84, 229, 97, 195, 95, 74, 85, 204, 143, 132, 4, 241, 94, 197, 178, 106&gt;&gt; {:ok, decoded} = Avrora.decode(message) [%{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99}] &lt;summary&gt;:mag: Click to expand for all available functions&lt;/summary&gt;### extract_schema/1Extracts a schema from the encoded message, useful when you would like to havesome metadata about the schema used to encode the message. All the retrieved schemaswill be cached accordingly to the settings.```elixir{:ok, pid} = Avrora.start_link()message = &lt;&lt;79, 98, 106, 1, 3, 204, 2, 20, 97, 118, 114, 111, 46, 99, 111, 100, 101, 99, 8, 110, 117, 108, 108, 22, 97, 118, 114, 111, 46, 115, 99, 104, 101, 109, 97, 144, 2, 123, 34, 110, 97, 109, 101, 115, 112, 97, 99, 101, 34, 58, 34, 105, 111, 46, 99, 111, 110, 102, 108, 117, 101, 110, 116, 34, 44, 34, 110, 97, 109, 101, 34, 58, 34, 80, 97, 121, 109, 101, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 114, 101, 99, 111, 114, 100, 34, 44, 34, 102, 105, 101, 108, 100, 115, 34, 58, 91, 123, 34, 110, 97, 109, 101, 34, 58, 34, 105, 100, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 115, 116, 114, 105, 110, 103, 34, 125, 44, 123, 34, 110, 97, 109, 101, 34, 58, 34, 97, 109, 111, 117, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 100, 111, 117, 98, 108, 101, 34, 125, 93, 125, 0, 84, 229, 97, 195, 95, 74, 85, 204, 143, 132, 4, 241, 94, 197, 178, 106, 2, 26, 8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64, 84, 229, 97, 195, 95, 74, 85, 204, 143, 132, 4, 241, 94, 197, 178, 106&gt;&gt;{:ok, schema} = Avrora.extract_schema(message){:ok, %Avrora.Schema{ full_name: &quot;io.confluent.Payment&quot;, id: nil, json: &quot;{\\&quot;namespace\\&quot;:\\&quot;io.confluent\\&quot;,\\&quot;name\\&quot;:\\&quot;Payment\\&quot;,\\&quot;type\\&quot;:\\&quot;record\\&quot;,\\&quot;fields\\&quot;:[{\\&quot;name\\&quot;:\\&quot;id\\&quot;,\\&quot;type\\&quot;:\\&quot;string\\&quot;},{\\&quot;name\\&quot;:\\&quot;amount\\&quot;,\\&quot;type\\&quot;:\\&quot;double\\&quot;}]}&quot;, lookup_table: #Reference&lt;0.146116641.3853647878.152744&gt;, version: nil }}```Mix tasksA separate mix task to register a specific schema or all found schemas in schemas folder (see configuration section) is available since v0.12.0.For instance, if you configure Avrora schemas folder to be at ./priv/schemas and you want to register a schema io/confluent/Payment.avsc then you can use this command$ mix avrora.reg.schema --name io.confluent.Payment schema `io.confluent.Payment` will be registeredNOTE: It will search for schema ./priv/schemas/io/confluent/Payment.avscIf you would like to register all schemas found under ./priv/schemas then you can simply execute this command$ mix avrora.reg.schema --all schema `io.confluent.Payment` will be registered schema `io.confluent.Wrong' will be skipped due to an error `argument error'","ref":"Avrora.html","title":"Avrora","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Avrora.html#child_spec/1","title":"Avrora.child_spec/1","type":"function"},{"doc":"See Avrora.Encoder.decode/1.","ref":"Avrora.html#decode/1","title":"Avrora.decode/1","type":"function"},{"doc":"See Avrora.Encoder.decode/2.","ref":"Avrora.html#decode/2","title":"Avrora.decode/2","type":"function"},{"doc":"See Avrora.Encoder.encode/2.","ref":"Avrora.html#encode/2","title":"Avrora.encode/2","type":"function"},{"doc":"See Avrora.Encoder.extract_schema/1.","ref":"Avrora.html#extract_schema/1","title":"Avrora.extract_schema/1","type":"function"},{"doc":"","ref":"Avrora.html#start_link/1","title":"Avrora.start_link/1","type":"function"},{"doc":"A host process and a wrapper for :avro_schema_store produced tables. It is used only to create new tables and no other functionality is coverd.This process will be in the same supervision tree as Avrora.Storage.Memory with a stragety one for all.See more:https://github.com/Strech/avrora/issues/21https://elixirforum.com/t/do-we-need-a-process-for-ets-tables/22705","ref":"Avrora.AvroSchemaStore.html","title":"Avrora.AvroSchemaStore","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Avrora.AvroSchemaStore.html#child_spec/1","title":"Avrora.AvroSchemaStore.child_spec/1","type":"function"},{"doc":"Creates a new Erlang Term Store.Examples:iex&gt; {:ok, _} = Avrora.AvroSchemaStore.start_link() iex&gt; Avrora.AvroSchemaStore.new() |&gt; :ets.info() |&gt; Keyword.get(:size) 0","ref":"Avrora.AvroSchemaStore.html#new/0","title":"Avrora.AvroSchemaStore.new/0","type":"function"},{"doc":"","ref":"Avrora.AvroSchemaStore.html#start_link/1","title":"Avrora.AvroSchemaStore.start_link/1","type":"function"},{"doc":"A behaviour for encoding/decoding Avro messages.","ref":"Avrora.Codec.html","title":"Avrora.Codec","type":"behaviour"},{"doc":"Decode a binary Avro message into the Elixir data.Examples...&gt; payload = &lt;&lt;0, 0, 0, 0, 8, 72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; ...&gt; Avrora.Codec.SchemaRegistry.decode(payload) {:ok, %{&quot;id&quot; =&gt; &quot;00000000-0000-0000-0000-000000000000&quot;, &quot;amount&quot; =&gt; 15.99}}","ref":"Avrora.Codec.html#c:decode/1","title":"Avrora.Codec.decode/1","type":"callback"},{"doc":"Decode a binary Avro message into the Elixir data with given schema.Examples...&gt; payload = &lt;&lt;72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; ...&gt; {:ok, schema} = Avrora.Resolver.resolve(&quot;io.confluent.Payment&quot;) ...&gt; Avrora.Codec.Plain.decode(payload, schema: schema) {:ok, %{&quot;id&quot; =&gt; &quot;00000000-0000-0000-0000-000000000000&quot;, &quot;amount&quot; =&gt; 15.99}}","ref":"Avrora.Codec.html#c:decode/2","title":"Avrora.Codec.decode/2","type":"callback"},{"doc":"Encode the Elixir data into a binary Avro message.Examples...&gt; payload = %{&quot;id&quot; =&gt; &quot;00000000-0000-0000-0000-000000000000&quot;, &quot;amount&quot; =&gt; 15.99} ...&gt; {:ok, schema} = Avrora.Resolver.resolve(&quot;io.confluent.Payment&quot;) ...&gt; Avrora.Codec.Plain.encode(payload, schema: schema) &lt;&lt;72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt;","ref":"Avrora.Codec.html#c:encode/2","title":"Avrora.Codec.encode/2","type":"callback"},{"doc":"Extract schema from the binary Avro message.Examples...&gt; payload = &lt;&lt;0, 0, 0, 0, 42, 72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; ...&gt; {:ok, schema} = Avrora.Codec.SchemaRegistry.extract_schema(payload) ...&gt; schema.id 42 ...&gt; schema.full_name &quot;io.confluent.Payment&quot;","ref":"Avrora.Codec.html#c:extract_schema/1","title":"Avrora.Codec.extract_schema/1","type":"callback"},{"doc":"Check either a given binary Avro message is decodable with a specific codec or not.NOTE: It's not guaranteed that a decodable binary message will be successfuly decoded.Examples...&gt; Avrora.Codec.Plain.is_decodable(&lt;&lt;1, 2, 3&gt;&gt;) true ...&gt; Avrora.Codec.SchemaRegistry.is_decodable(&lt;&lt;1, 2, 3&gt;&gt;) false","ref":"Avrora.Codec.html#c:is_decodable/1","title":"Avrora.Codec.is_decodable/1","type":"callback"},{"doc":"An Avro encoder/decoder working with an Object Container File formatted Avro messages.It works with a binary format, which includes a required schema inside the message. See more about Object Container File.","ref":"Avrora.Codec.ObjectContainerFile.html","title":"Avrora.Codec.ObjectContainerFile","type":"module"},{"doc":"An Avro encoder/decoder working with a plain Avro messages.It works with a binary format, which doesn't include any schema inside like Object Container File or the magic bytes for a Schema Registry.","ref":"Avrora.Codec.Plain.html","title":"Avrora.Codec.Plain","type":"module"},{"doc":"An Avro encoder/decoder working with a Schema Registry formatted Avro messages.It works with a binary format, which includes a required schema global ID inside the message. See more about Schema Registry.","ref":"Avrora.Codec.SchemaRegistry.html","title":"Avrora.Codec.SchemaRegistry","type":"module"},{"doc":"Configuration for Avrora.Options:* `schemas_path` path to local schema files, default `./priv/schemas` * `registry_url` URL for Schema Registry, default `nil` * `registry_auth` authentication settings for Schema Registry, default `nil` * `registry_schemas_autoreg` automatically register schemas in Schema Registry, default `true` * `names_cache_ttl` duration to cache global schema names millisecods, default `:infinity`Internal use interface:* `file_storage` module which handles files in `schemas_path`, default `Avrora.Storage.File` * `memory_storage` module which handles memory operations, default `Avrora.Storage.Memory` * `registry_storage` module which handles Schema Registry requests, default `Avrora.Storage.Registry` * `http_client` module which handles HTTP client requests to Schema Registry, default `Avrora.HTTPClient` * `ets_lib` module which creates ETS tables with call `Module.new/0`","ref":"Avrora.Config.html","title":"Avrora.Config","type":"behaviour"},{"doc":"","ref":"Avrora.Config.html#c:ets_lib/0","title":"Avrora.Config.ets_lib/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:file_storage/0","title":"Avrora.Config.file_storage/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:http_client/0","title":"Avrora.Config.http_client/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:memory_storage/0","title":"Avrora.Config.memory_storage/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:names_cache_ttl/0","title":"Avrora.Config.names_cache_ttl/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:registry_auth/0","title":"Avrora.Config.registry_auth/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:registry_schemas_autoreg/0","title":"Avrora.Config.registry_schemas_autoreg/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:registry_storage/0","title":"Avrora.Config.registry_storage/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:registry_url/0","title":"Avrora.Config.registry_url/0","type":"callback"},{"doc":"","ref":"Avrora.Config.html#c:schemas_path/0","title":"Avrora.Config.schemas_path/0","type":"callback"},{"doc":"Encode and decode binary Avro messages.","ref":"Avrora.Encoder.html","title":"Avrora.Encoder","type":"module"},{"doc":"Decode binary Avro message, loading schema from Schema Registry or Object Container Files.Examples...&gt; payload = &lt;&lt;0, 0, 0, 0, 8, 72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; ...&gt; Avrora.Encoder.decode(payload) {:ok, %{&quot;id&quot; =&gt; &quot;00000000-0000-0000-0000-000000000000&quot;, &quot;amount&quot; =&gt; 15.99}}","ref":"Avrora.Encoder.html#decode/1","title":"Avrora.Encoder.decode/1","type":"function"},{"doc":"Decode binary Avro message, loading schema from local file or Schema Registry.Examples...&gt; payload = &lt;&lt;72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; ...&gt; Avrora.Encoder.decode(payload, schema_name: &quot;io.confluent.Payment&quot;) {:ok, %{&quot;id&quot; =&gt; &quot;00000000-0000-0000-0000-000000000000&quot;, &quot;amount&quot; =&gt; 15.99}}","ref":"Avrora.Encoder.html#decode/2","title":"Avrora.Encoder.decode/2","type":"function"},{"doc":"Encode message map in Avro format, loading schema from local file or Schema Registry.The :format argument controls output format::plain - Just return Avro binary data, with no header or embedded schema:ocf - Use [Object Container File]https://avro.apache.org/docs/1.8.1/spec.html#Object+Container+Files) format, embedding the full schema with the data:registry - Write data with Confluent Schema Registry Wire Format, which prefixes the data with the schema id:guess - Use :registry if possible, otherwise use :ocf (default)Examples...&gt; payload = %{&quot;id&quot; =&gt; &quot;00000000-0000-0000-0000-000000000000&quot;, &quot;amount&quot; =&gt; 15.99} ...&gt; Avrora.Encoder.encode(payload, schema_name: &quot;io.confluent.Payment&quot;, format: :plain) {:ok, &lt;&lt;72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt;}","ref":"Avrora.Encoder.html#encode/2","title":"Avrora.Encoder.encode/2","type":"function"},{"doc":"Extract schema from the binary Avro message.Examples...&gt; payload = &lt;&lt;0, 0, 0, 0, 8, 72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; ...&gt; {:ok, schema} = Avrora.Encoder.extract_schema(payload) ...&gt; schema.id 42 ...&gt; schema.full_name &quot;io.confluent.Payment&quot;","ref":"Avrora.Encoder.html#extract_schema/1","title":"Avrora.Encoder.extract_schema/1","type":"function"},{"doc":"Minimal HTTP client using built-in Erlang httpc library.","ref":"Avrora.HTTPClient.html","title":"Avrora.HTTPClient","type":"behaviour"},{"doc":"","ref":"Avrora.HTTPClient.html#c:get/2","title":"Avrora.HTTPClient.get/2","type":"callback"},{"doc":"","ref":"Avrora.HTTPClient.html#c:post/3","title":"Avrora.HTTPClient.post/3","type":"callback"},{"doc":"Functions to convert between common Elixir structures and erlavro structures.","ref":"Avrora.Mapper.html","title":"Avrora.Mapper","type":"module"},{"doc":"Convert tuple-based structure returned by erlavro to Elixir map.Examplesiex&gt; map = Avrora.Mapper.to_map([{:a, 1}, {&quot;b&quot;, [nil, 11.1, &quot;three&quot;]}, {:c, [{:hello, &quot;world&quot;}]}]) iex&gt; %{&quot;a&quot; =&gt; a, &quot;b&quot; =&gt; b, &quot;c&quot; =&gt; c} = map iex&gt; a 1 iex&gt; b [nil, 11.1, &quot;three&quot;] iex&gt; c %{&quot;hello&quot; =&gt; &quot;world&quot;}","ref":"Avrora.Mapper.html#to_map/1","title":"Avrora.Mapper.to_map/1","type":"function"},{"doc":"Resolve schema name or global ID to a schema, keeping cache up to date.","ref":"Avrora.Resolver.html","title":"Avrora.Resolver","type":"module"},{"doc":"Resolve schema by string name with optional version.Version can be provided by adding : and version number, e.g. io.confluent.Payment:5.If the Schema Registry is configured (:registry_url), it will first try there, then local schemas folder (:schemas_path).Stores schema in memory with key name and name:version and adds schema to registry if configured.Examples...&gt; {:ok, schema1} = Avrora.Resolver.resolve(&quot;io.confluent.Payment&quot;) ...&gt; {:ok, schema2} = Avrora.Resolver.resolve(&quot;io.confluent.Payment:42&quot;) ...&gt; schema1.version 42 ...&gt; schema2.version 42 ...&gt; schema1.full_name &quot;io.confluent.Payment&quot; ...&gt; schema.full_name &quot;io.confluent.Payment&quot;","ref":"Avrora.Resolver.html#resolve/1","title":"Avrora.Resolver.resolve/1","type":"function"},{"doc":"Resolve schema, trying multiple methods. First tries integer id, then string name.Examples...&gt; {:ok, schema} = Avrora.Resolver.resolve_any([1, &quot;io.confluent.Payment&quot;]) ...&gt; schema.full_name &quot;io.confluent.Payment&quot;","ref":"Avrora.Resolver.html#resolve_any/1","title":"Avrora.Resolver.resolve_any/1","type":"function"},{"doc":"Convenience wrapper struct for erlavro records.","ref":"Avrora.Schema.html","title":"Avrora.Schema","type":"module"},{"doc":"Convert erlavro format to the struct.Examplesiex&gt; payload = ...&gt; {:avro_record_type, &quot;Payment&quot;, &quot;io.confluent&quot;, &quot;&quot;, [], ...&gt; [ ...&gt; {:avro_record_field, &quot;id&quot;, &quot;&quot;, {:avro_primitive_type, &quot;string&quot;, []}, :undefined, ...&gt; :ascending, []}, ...&gt; {:avro_record_field, &quot;amount&quot;, &quot;&quot;, {:avro_primitive_type, &quot;double&quot;, []}, :undefined, ...&gt; :ascending, []} ...&gt; ], &quot;io.confluent.Payment&quot;, []} iex&gt; {:ok, schema} = Avrora.Schema.from_erlavro(payload) iex&gt; schema.id nil iex&gt; schema.full_name &quot;io.confluent.Payment&quot;","ref":"Avrora.Schema.html#from_erlavro/2","title":"Avrora.Schema.from_erlavro/2","type":"function"},{"doc":"Parse Avro schema JSON and convert to struct.Examplesiex&gt; json = ~s({&quot;namespace&quot;:&quot;io.confluent&quot;,&quot;type&quot;:&quot;record&quot;,&quot;name&quot;:&quot;Payment&quot;,&quot;fields&quot;:[{&quot;name&quot;:&quot;id&quot;,&quot;type&quot;:&quot;string&quot;},{&quot;name&quot;:&quot;amount&quot;,&quot;type&quot;:&quot;double&quot;}]}) iex&gt; {:ok, schema} = Avrora.Schema.parse(json) iex&gt; schema.full_name &quot;io.confluent.Payment&quot;","ref":"Avrora.Schema.html#parse/2","title":"Avrora.Schema.parse/2","type":"function"},{"doc":"An example of a reference lookup which returns empty JSON body","ref":"Avrora.Schema.html#reference_lookup/1","title":"Avrora.Schema.reference_lookup/1","type":"function"},{"doc":"Convert struct to erlavro format and look it up in avro_schema_store.Examplesiex&gt; json = ~s({&quot;namespace&quot;:&quot;io.confluent&quot;,&quot;type&quot;:&quot;record&quot;,&quot;name&quot;:&quot;Payment&quot;,&quot;fields&quot;:[{&quot;name&quot;:&quot;id&quot;,&quot;type&quot;:&quot;string&quot;},{&quot;name&quot;:&quot;amount&quot;,&quot;type&quot;:&quot;double&quot;}]}) iex&gt; {:ok, schema} = Avrora.Schema.parse(json) iex&gt; {:ok, {type, _, _, _, _, _, full_name, _}} = Avrora.Schema.to_erlavro(schema) iex&gt; full_name &quot;io.confluent.Payment&quot; iex&gt; type :avro_record_type","ref":"Avrora.Schema.html#to_erlavro/1","title":"Avrora.Schema.to_erlavro/1","type":"function"},{"doc":"","ref":"Avrora.Schema.html#t:reference_lookup_fun/0","title":"Avrora.Schema.reference_lookup_fun/0","type":"type"},{"doc":"","ref":"Avrora.Schema.html#t:t/0","title":"Avrora.Schema.t/0","type":"type"},{"doc":"Struct for versioned schema names like io.confluent.Payment:42.","ref":"Avrora.Schema.Name.html","title":"Avrora.Schema.Name","type":"module"},{"doc":"Parse schema name with optional version, returning struct.Examplesiex&gt; Avrora.Schema.Name.parse(&quot;Payment&quot;) {:ok, %Avrora.Schema.Name{origin: &quot;Payment&quot;, name: &quot;Payment&quot;, version: nil}} iex&gt; Avrora.Schema.Name.parse(&quot;io.confluent.Payment:42&quot;) {:ok, %Avrora.Schema.Name{origin: &quot;io.confluent.Payment:42&quot;, name: &quot;io.confluent.Payment&quot;, version: 42}}","ref":"Avrora.Schema.Name.html#parse/1","title":"Avrora.Schema.Name.parse/1","type":"function"},{"doc":"","ref":"Avrora.Schema.Name.html#t:t/0","title":"Avrora.Schema.Name.t/0","type":"type"},{"doc":"Collect non local type references from erlavro structures.","ref":"Avrora.Schema.ReferenceCollector.html","title":"Avrora.Schema.ReferenceCollector","type":"module"},{"doc":"Collect non local type referenced types from erlavro structure.Type definition aliases counted as type definitions too.Every json-string type value considered to be a reference if it's not one of the reserved by Avro Specification types, such as:int - null - enumlong - boolean - arrayfloat - string - mapdouble - record - unionbytes - fixedExamplesiex&gt; json_schema = File.read!(&quot;test/fixtures/schemas/io/confluent/Account.avsc&quot;) iex&gt; erlavro = :avro_json_decoder.decode_schema(json_schema, allow_bad_references: true) iex&gt; Avrora.Schema.ReferenceCollector.collect(erlavro) {:ok, [&quot;io.confluent.Email&quot;, &quot;io.confluent.Messenger&quot;, &quot;io.confluent.PaymentHistory&quot;]}","ref":"Avrora.Schema.ReferenceCollector.html#collect/1","title":"Avrora.Schema.ReferenceCollector.collect/1","type":"function"},{"doc":"Behavior for storing and getting schemas by name or integer ID.","ref":"Avrora.Storage.html","title":"Avrora.Storage","type":"behaviour"},{"doc":"","ref":"Avrora.Storage.html#c:get/1","title":"Avrora.Storage.get/1","type":"callback"},{"doc":"","ref":"Avrora.Storage.html#c:put/2","title":"Avrora.Storage.put/2","type":"callback"},{"doc":"Schema indentifier.","ref":"Avrora.Storage.html#t:schema_id/0","title":"Avrora.Storage.schema_id/0","type":"type"},{"doc":"Avora.Storage behavior implementation which uses the filesystem.Schema name &lt;namespace&gt;.&lt;namespace&gt;.&lt;name&gt; will be stored to path namespace/namespace/name.avsc.","ref":"Avrora.Storage.File.html","title":"Avrora.Storage.File","type":"module"},{"doc":"Avora.Storage behavior implementation which uses memory (ETS).Schemas can be accessed by integer id or full name.","ref":"Avrora.Storage.Memory.html","title":"Avrora.Storage.Memory","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Avrora.Storage.Memory.html#child_spec/1","title":"Avrora.Storage.Memory.child_spec/1","type":"function"},{"doc":"Delete data from storage by key. Always succeeds, whether or not the key exists.Examplesiex&gt; _ = Avrora.Storage.Memory.start_link() iex&gt; schema = %Avrora.Schema{id: nil, json: &quot;{}&quot;} iex&gt; Avrora.Storage.Memory.put(&quot;my-key&quot;, schema) {:ok, %Avrora.Schema{id: nil, json: &quot;{}&quot;}} iex&gt; Avrora.Storage.Memory.get(&quot;my-key&quot;) {:ok, %Avrora.Schema{id: nil, json: &quot;{}&quot;}} iex&gt; Avrora.Storage.Memory.delete(&quot;my-key&quot;) {:ok, true} iex&gt; Avrora.Storage.Memory.get(&quot;my-key&quot;) {:ok, nil}","ref":"Avrora.Storage.Memory.html#delete/1","title":"Avrora.Storage.Memory.delete/1","type":"function"},{"doc":"Tell storage module to delete data after TTL (time to live) expires. Works whether or not the key exists. TTL is in milliseconds.Examples...&gt; _ = Avrora.Storage.Memory.start_link() ...&gt; schema = %Avrora.Schema{id: nil, json: &quot;{}&quot;} ...&gt; Avrora.Storage.Memory.put(&quot;my-key&quot;, schema) {:ok, %Avrora.Schema{id: nil, json: &quot;{}&quot;}} ...&gt; {:ok, _} = Avrora.Storage.Memory.expire(&quot;my-key&quot;, 100) ...&gt; Avrora.Storage.Memory.get(&quot;my-key&quot;) {:ok, %Avrora.Schema{id: nil, json: &quot;{}&quot;}} ...&gt; Process.sleep(200) ...&gt; Avrora.Storage.Memory.get(&quot;my-key&quot;) {:ok, nil}","ref":"Avrora.Storage.Memory.html#expire/2","title":"Avrora.Storage.Memory.expire/2","type":"function"},{"doc":"Complete clean up of the storage. Useful for testing.Examplesiex&gt; _ = Avrora.Storage.Memory.start_link() iex&gt; schema = %Avrora.Schema{id: nil, json: &quot;{}&quot;} iex&gt; Avrora.Storage.Memory.put(&quot;my-key&quot;, schema) {:ok, %Avrora.Schema{id: nil, json: &quot;{}&quot;}} iex&gt; {:ok, _} = Avrora.Storage.Memory.flush() iex&gt; Avrora.Storage.Memory.get(&quot;my-key&quot;) {:ok, nil}","ref":"Avrora.Storage.Memory.html#flush/0","title":"Avrora.Storage.Memory.flush/0","type":"function"},{"doc":"Get schema by key.Examplesiex&gt; _ = Avrora.Storage.Memory.start_link() iex&gt; Avrora.Storage.Memory.put(&quot;my-key&quot;, %{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, %{&quot;hello&quot; =&gt; &quot;world&quot;}} iex&gt; Avrora.Storage.Memory.get(&quot;my-key&quot;) {:ok, %{&quot;hello&quot; =&gt; &quot;world&quot;}} iex&gt; Avrora.Storage.Memory.get(&quot;unknown-key&quot;) {:ok, nil}","ref":"Avrora.Storage.Memory.html#get/1","title":"Avrora.Storage.Memory.get/1","type":"function"},{"doc":"Store schema by key. If value already exists it will be replaced.Examplesiex&gt; _ = Avrora.Storage.Memory.start_link() iex&gt; schema = %Avrora.Schema{id: nil, json: &quot;{}&quot;} iex&gt; Avrora.Storage.Memory.put(&quot;my-key&quot;, schema) {:ok, %Avrora.Schema{id: nil, json: &quot;{}&quot;}}","ref":"Avrora.Storage.Memory.html#put/2","title":"Avrora.Storage.Memory.put/2","type":"function"},{"doc":"","ref":"Avrora.Storage.Memory.html#start_link/1","title":"Avrora.Storage.Memory.start_link/1","type":"function"},{"doc":"Avora.Storage behavior implementation which uses Confluent Schema Registry.This only implements the minimum client functionality needed to talk with the registry. Inspired by Schemex.","ref":"Avrora.Storage.Registry.html","title":"Avrora.Storage.Registry","type":"module"},{"doc":"Get schema by integer ID.Examples...&gt; {:ok, schema} = Avrora.Storage.Registry.get(1) ...&gt; schema.full_name &quot;io.confluent.Payment&quot;","ref":"Avrora.Storage.Registry.html#get/1","title":"Avrora.Storage.Registry.get/1","type":"function"},{"doc":"Storage behavior which allows keys to be removed or expired.","ref":"Avrora.Storage.Transient.html","title":"Avrora.Storage.Transient","type":"behaviour"},{"doc":"","ref":"Avrora.Storage.Transient.html#c:delete/1","title":"Avrora.Storage.Transient.delete/1","type":"callback"},{"doc":"","ref":"Avrora.Storage.Transient.html#c:expire/2","title":"Avrora.Storage.Transient.expire/2","type":"callback"},{"doc":"","ref":"Avrora.Storage.Transient.html#c:flush/0","title":"Avrora.Storage.Transient.flush/0","type":"callback"},{"doc":"Naive timestamp with second precision.","ref":"Avrora.Storage.Transient.html#t:timestamp/0","title":"Avrora.Storage.Transient.timestamp/0","type":"type"},{"doc":"An ExUnit helper.","ref":"Avrora.TestCase.html","title":"Avrora.TestCase","type":"module"},{"doc":"A hook function to be used in setup-hook to clean memory storage. ## Examples: defmodule MyTest do use ExUnit.Case, async: true import Avrora.TestCase setup :cleanup_storage! test &quot;memory storage was filled&quot; do asset Avrora.Storage.Memory.get(&quot;some&quot;) == nil Avrora.Storage.Memory.put(&quot;some&quot;, 42) asset Avrora.Storage.Memory.get(&quot;some&quot;) == 42 end test &quot;memory storage is clean&quot; do asset Avrora.Storage.Memory.get(&quot;some&quot;) == nil end end","ref":"Avrora.TestCase.html#cleanup_storage!/1","title":"Avrora.TestCase.cleanup_storage!/1","type":"function"},{"doc":"Register either one schema or all schemas in the Avrora.Config.schemas_path directory.mix avrora.reg.schema [--all] [--name NAME]The search of the schemas will be performed under path configured in schemas_path configuration option. One of either option must be given.Options--name - the full name of the schema to register (exclusive with --all)--all - register all found schemasThe --name option expects that given schema name will comply to Avrora.Storage.File module rules.For example, if the schema name is io.confluent.Payment it should be stored as &lt;schemas path&gt;/io/confluent/Payment.avscUsagemix avrora.reg.schema --name io.confluent.Payment mix avrora.reg.schema --all","ref":"Mix.Tasks.Avrora.Reg.Schema.html","title":"Mix.Tasks.Avrora.Reg.Schema","type":"task"},{"doc":"&lt;img id=&quot;avroraLogo&quot; width=200 src=&quot;/assets/logo.png&quot;/&gt; &lt;h1 align=&quot;center&quot;&gt;Avrora&lt;/h1&gt;[![Hex pm](https://img.shields.io/hexpm/v/avrora.svg?style=for-the-badge)](https://hex.pm/packages/avrora)[![Hex Docs](https://img.shields.io/badge/api-docs-blue.svg?style=for-the-badge)](https://hexdocs.pm/avrora)[![Build Status](https://img.shields.io/travis/Strech/avrora/master?style=for-the-badge)](https://travis-ci.org/Strech/avrora)Getting StartedThis library supports convenient encoding and decoding of Avro messages.It can read the Avro schema from local files or the Confluent® Schema Registry, caching data in memory for performance. It supports reading and writing data Kafka wire format prefix and from Object Container Files formats. And has Inter-Schema references feature.Many thanks to the AvroTurf Ruby gem for the inspiration.","ref":"readme.html","title":"Getting Started","type":"extras"},{"doc":"Add Avrora to mix.exs as a dependency:def deps do [ {:avrora, &quot;~&gt; 0.13&quot;} ] end","ref":"readme.html#add-avrora-to-your-project","title":"Getting Started - Add Avrora to your project","type":"extras"},{"doc":"Configure the library in config/config.exs:config :avrora, registry_url: &quot;http://localhost:8081&quot;, registy_auth: {:basic, [&quot;username&quot;, &quot;password&quot;]}, # optional registy_schemas_autoreg: false, # optional: if you want manually register schemas schemas_path: Path.expand(&quot;./priv/schemas&quot;), names_cache_ttl: :timer.minutes(5) # optional: if you want periodic disk readsregistry_url - URL for the Schema Registry, default nilregistry_auth – Credentials to authenticate in the Schema Registry, default nilregisty_schemas_autoreg - Flag for automatic schemas registration in the Schema Registry, default true (since v0.13)schemas_path - Base path for locally stored schema files, default ./priv/schemasnames_cache_ttl - Time in ms to cache schemas by name in memory, default :infinity (since v0.10)Set names_cache_ttl to :infinity will cache forever (no more disk reads will happen). This is safe when schemas are resolved in the Schema Registry by numeric id or versioned name, as it is unique. If you need to reload schema from the disk periodically, TTL different from :infinity ensures that.If the schema is resolved by name it will be always overwritten with the latest schema received from Schema Registry (this is a new behavior since v0.10).:bulb: Disable automatic schemas registration if you want to avoid storing schemas and manually control registration process.","ref":"readme.html#configuration","title":"Getting Started - Configuration","type":"extras"},{"doc":"Avrora uses an in-memory cache to speed up schema lookup.Add it to your supervision tree:children = [ Avrora ] Supervisor.start_link(children, strategy: :one_for_one)Or start the cache process manually:{:ok, pid} = Avrora.start_link()","ref":"readme.html#start-cache-process","title":"Getting Started - Start cache process","type":"extras"},{"doc":"The primary way to use the library is via the Avrora.encode/2 and Avrora.decode/2 functions. These functions load the Avro schema for you.If registry_url is defined, it enables Schema Registry storage. If the schema file found locally but not in the registry, either fuction will register the schema.These examples assume you have a Payment schema stored in the file priv/schemas/io/confluent/Payment.avsc:{ &quot;type&quot;: &quot;record&quot;, &quot;name&quot;: &quot;Payment&quot;, &quot;namespace&quot;: &quot;io.confluent&quot;, &quot;fields&quot;: [ { &quot;name&quot;: &quot;id&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;amount&quot;, &quot;type&quot;: &quot;double&quot; } ] }When running interactively, first make sure the cache is started:{:ok, pid} = Avrora.start_link()encode/2To encode a Payment message:{:ok, pid} = Avrora.start_link() message = %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99} {:ok, encoded} = Avrora.encode(message, schema_name: &quot;io.confluent.Payment&quot;) &lt;&lt;79, 98, 106, 1, 3, 204, 2, 20, 97, 118, 114, 111, 46, 99, 111, 100, 101, 99, 8, 110, 117, 108, 108, 22, 97, 118, 114, 111, 46, 115, 99, 104, 101, 109, 97, 144, 2, 123, 34, 110, 97, 109, 101, 115, 112, 97, 99, 101, 34, 58, 34, 105, 111, 46, 99, 111, 110, 102, 108, 117, 101, 110, 116, 34, 44, 34, 110, 97, 109, 101, 34, 58, 34, 80, 97, 121, 109, 101, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 114, 101, 99, 111, 114, 100, 34, 44, 34, 102, 105, 101, 108, 100, 115, 34, 58, 91, 123, 34, 110, 97, 109, 101, 34, 58, 34, 105, 100, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 115, 116, 114, 105, 110, 103, 34, 125, 44, 123, 34, 110, 97, 109, 101, 34, 58, 34, 97, 109, 111, 117, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 100, 111, 117, 98, 108, 101, 34, 125, 93, 125, 0, 138, 124, 66, 49, 157, 51, 242, 3, 33, 52, 161, 147, 221, 174, 114, 48, 2, 26, 8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64, 138, 124, 66, 49, 157, 51, 242, 3, 33, 52, 161, 147, 221, 174, 114, 48&gt;&gt;The :format argument controls output format::plain - Just return Avro binary data, with no header or embedded schema:ocf - Use Object Container File format, embedding the full schema with the data:registry - Write data with Confluent Schema Registry Wire Format, which prefixes the data with the schema id:guess - Use :registry if possible, otherwise use :ocf (default){:ok, pid} = Avrora.start_link() message = %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99} {:ok, encoded} = Avrora.encode(message, schema_name: &quot;io.confluent.Payment&quot;, format: :plain) &lt;&lt;8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt;decode/2Decode Payment message using the specified schema:{:ok, pid} = Avrora.start_link() message = &lt;&lt;8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; {:ok, decoded} = Avrora.decode(message, schema_name: &quot;io.confluent.Payment&quot;) %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99}decode/1Decode a message, auto-detecting the schema using magic bytes. It first tries resolving the schema using the integer id in the wire format header.Next it tries reading using the Object Container Files embedded schema.NOTE: Messages encoded with OCF are wrapped in a List.{:ok, pid} = Avrora.start_link() message = &lt;&lt;79, 98, 106, 1, 3, 204, 2, 20, 97, 118, 114, 111, 46, 99, 111, 100, 101, 99, 8, 110, 117, 108, 108, 22, 97, 118, 114, 111, 46, 115, 99, 104, 101, 109, 97, 144, 2, 123, 34, 110, 97, 109, 101, 115, 112, 97, 99, 101, 34, 58, 34, 105, 111, 46, 99, 111, 110, 102, 108, 117, 101, 110, 116, 34, 44, 34, 110, 97, 109, 101, 34, 58, 34, 80, 97, 121, 109, 101, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 114, 101, 99, 111, 114, 100, 34, 44, 34, 102, 105, 101, 108, 100, 115, 34, 58, 91, 123, 34, 110, 97, 109, 101, 34, 58, 34, 105, 100, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 115, 116, 114, 105, 110, 103, 34, 125, 44, 123, 34, 110, 97, 109, 101, 34, 58, 34, 97, 109, 111, 117, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 100, 111, 117, 98, 108, 101, 34, 125, 93, 125, 0, 84, 229, 97, 195, 95, 74, 85, 204, 143, 132, 4, 241, 94, 197, 178, 106, 2, 26, 8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64, 84, 229, 97, 195, 95, 74, 85, 204, 143, 132, 4, 241, 94, 197, 178, 106&gt;&gt; {:ok, decoded} = Avrora.decode(message) [%{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99}] &lt;summary&gt;:mag: Click to expand for all available functions&lt;/summary&gt;### extract_schema/1Extracts a schema from the encoded message, useful when you would like to havesome metadata about the schema used to encode the message. All the retrieved schemaswill be cached accordingly to the settings.```elixir{:ok, pid} = Avrora.start_link()message = &lt;&lt;79, 98, 106, 1, 3, 204, 2, 20, 97, 118, 114, 111, 46, 99, 111, 100, 101, 99, 8, 110, 117, 108, 108, 22, 97, 118, 114, 111, 46, 115, 99, 104, 101, 109, 97, 144, 2, 123, 34, 110, 97, 109, 101, 115, 112, 97, 99, 101, 34, 58, 34, 105, 111, 46, 99, 111, 110, 102, 108, 117, 101, 110, 116, 34, 44, 34, 110, 97, 109, 101, 34, 58, 34, 80, 97, 121, 109, 101, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 114, 101, 99, 111, 114, 100, 34, 44, 34, 102, 105, 101, 108, 100, 115, 34, 58, 91, 123, 34, 110, 97, 109, 101, 34, 58, 34, 105, 100, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 115, 116, 114, 105, 110, 103, 34, 125, 44, 123, 34, 110, 97, 109, 101, 34, 58, 34, 97, 109, 111, 117, 110, 116, 34, 44, 34, 116, 121, 112, 101, 34, 58, 34, 100, 111, 117, 98, 108, 101, 34, 125, 93, 125, 0, 84, 229, 97, 195, 95, 74, 85, 204, 143, 132, 4, 241, 94, 197, 178, 106, 2, 26, 8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64, 84, 229, 97, 195, 95, 74, 85, 204, 143, 132, 4, 241, 94, 197, 178, 106&gt;&gt;{:ok, schema} = Avrora.extract_schema(message){:ok, %Avrora.Schema{ full_name: &quot;io.confluent.Payment&quot;, id: nil, json: &quot;{\\&quot;namespace\\&quot;:\\&quot;io.confluent\\&quot;,\\&quot;name\\&quot;:\\&quot;Payment\\&quot;,\\&quot;type\\&quot;:\\&quot;record\\&quot;,\\&quot;fields\\&quot;:[{\\&quot;name\\&quot;:\\&quot;id\\&quot;,\\&quot;type\\&quot;:\\&quot;string\\&quot;},{\\&quot;name\\&quot;:\\&quot;amount\\&quot;,\\&quot;type\\&quot;:\\&quot;double\\&quot;}]}&quot;, lookup_table: #Reference&lt;0.146116641.3853647878.152744&gt;, version: nil }}```","ref":"readme.html#usage","title":"Getting Started - Usage","type":"extras"},{"doc":"A separate mix task to register a specific schema or all found schemas in schemas folder (see configuration section) is available since v0.12.0.For instance, if you configure Avrora schemas folder to be at ./priv/schemas and you want to register a schema io/confluent/Payment.avsc then you can use this command$ mix avrora.reg.schema --name io.confluent.Payment schema `io.confluent.Payment` will be registeredNOTE: It will search for schema ./priv/schemas/io/confluent/Payment.avscIf you would like to register all schemas found under ./priv/schemas then you can simply execute this command$ mix avrora.reg.schema --all schema `io.confluent.Payment` will be registered schema `io.confluent.Wrong' will be skipped due to an error `argument error'","ref":"readme.html#mix-tasks","title":"Getting Started - Mix tasks","type":"extras"}]